#!/bin/zsh

out=sample.csv
src="$1"

[ -z "$src" ] && src=stuff-ref.wav

noisecompare() {
  ./audio.R "$1" "$2" 2> /dev/null
}

teeap() {
  echo "$*" | tee -a sample.csv
}

teeap "fname,bitrate,format,filesize,deltas"

foreach i (`seq 32 10 320 ` ) {
  oggenc --quiet -b $i "$src" -o foo.ogg > /dev/null
  avconv -i foo.ogg -y foo-ogg.wav 2> /dev/null  && rm foo.ogg
  sox foo-ogg.wav foo-ogg2.wav && mv foo-ogg2.wav foo-ogg.wav
  d=$(noisecompare $src foo-ogg.wav)
  sz=$(stat -c %s foo-ogg.wav)
  teeap "\"$src\"","$i","ogg",$sz,$d
  
  lame --quiet  --abr $i "$src" foo.mp3 > /dev/null
  lame --quiet --decode foo.mp3 foo-mp3.wav && rm foo.mp3
  d=$(noisecompare $src foo-mp3.wav)
  sz=$(stat -c %s foo-mp3.wav)
  teeap "\"$src\"","$i","mp3",$sz,$d
  
  lame --quiet  --cbr -b $i "$src" foo.mp3 > /dev/null
  lame --quiet --decode foo.mp3 foo-mp3.wav && rm foo.mp3
  d=$(noisecompare $src foo-mp3.wav)
  sz=$(stat -c %s foo-mp3.wav)
  teeap "\"$src\"","$i","mp3-cbr",$sz,$d
  
  lame --quiet  --abr $i -h "$src" foo.mp3 > /dev/null
  lame --quiet --decode foo.mp3 foo-mp3.wav && rm foo.mp3
  d=$(noisecompare $src foo-mp3.wav)
  sz=$(stat -c %s foo-mp3.wav)
  teeap "\"$src\"","$i","mp3h",$sz,$d
   
  lame --quiet  --abr $i -b 100 -h "$src" foo.mp3 > /dev/null
  lame --quiet --decode foo.mp3 foo-mp3.wav && rm foo.mp3
  d=$(noisecompare $src foo-mp3.wav)
  sz=$(stat -c %s foo-mp3.wav)
  teeap "\"$src\"","$i","mp3hu",$sz,$d
  
  faac -q 100 -b $i -o foo.aac "$src" 2> /dev/null
  faad -o foo.wav foo.aac 2> /dev/null && rm foo.aac
  sox foo.wav foo-aac.wav && rm foo.wav
  d=$(noisecompare $src foo-aac.wav)
  sz=$(stat -c %s foo-aac.wav)
  teeap "\"$src\"","$i","AAC-100",$sz,$d
  
  faac -q 80 -b $i -o foo.aac "$src" 2> /dev/null
  faad -o foo.wav foo.aac 2> /dev/null && rm foo.aac
  sox foo.wav foo-aac.wav && rm foo.wav
  d=$(noisecompare $src foo-aac.wav)
  sz=$(stat -c %s foo-aac.wav)
  teeap "\"$src\"","$i","AAC-80",$sz,$d
}

rm foo*{ogg,wav,mp3,aac}
